#pragma once

#include <Windows.h>
#include "types.h"
#include "cyapi.h"
#include "cusb2.h"

class spa3
{
	cusb2 *usb;
	CCyUSBEndPoint *inep;
	CCyUSBEndPoint *outep;
	LONG olen, ilen;
	u8 odata[64];
	u8 idata[64];
	u8 *fw_iic;

public:
	spa3(void);
	~spa3(void);

	bool init(cusb2 *usb, u64 *dev_dna, u8 *bit_buf);
	void port(u8 bits, u8 *out, u8 *in);
	void mem_read(u16 addr, u16 word, u16 *buf);
	void mem_write(u16 addr, u16 word, u16 *buf);

	void ep6in_start();
	void ep6in_stop();
	void ep2out_start();
	void ep2out_stop();
	void portd_cfg(u8 dir);
	u8   portd_read();
	void portd_write(u8 val);
	void ifconfig(u8 val);
	void set_fifo_8();
	void set_fifo_16();

private:
	void usb_trx();
};

