`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    14:15:45 07/19/2012 
// Design Name: 
// Module Name:    io_dna 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module io_dna(FX2_SLOE, FX2_SLRD, FX2_SLWR, FX2_FD, FX2_FIFOADR, FX2_PKTEND,
		FX2_FLAGA, FX2_FLAGB, FX2_FLAGC, FX2_IFCLK, CLK12
		);

	output FX2_SLOE;
	output FX2_SLRD;
	output FX2_SLWR;
	inout  [15:0] FX2_FD;
	output [1:0] FX2_FIFOADR;
	output FX2_PKTEND;
	input  FX2_FLAGA;
	input  FX2_FLAGB;
	input  FX2_FLAGC;
	input  FX2_IFCLK;

	input  CLK12;

	//fixed output pins
	assign FX2_SLOE = 1;
	assign FX2_SLRD = 1;
	assign FX2_SLWR = 1;
	assign FX2_FIFOADR = 3;
	assign FX2_PKTEND = 1;

	wire [57:0] in_port;
	wire [57:0] out_port;

	jtag_port #(58) jtag_port(.OUT_PORT(out_port), .IN_PORT(in_port));

	wire [56:0] dev_dna;
	wire dna_ready;

	dna dna(.dev_dna(dev_dna), .dna_ready(dna_ready), .clk(CLK12));

	wire security;
	wire [31:0] key_code;
	assign key_code = out_port[31:0];


	assign security = (key_code == ({7'b0000000, dev_dna[56:32]} ^ dev_dna[31:0])) ? 1 : 0;
	assign in_port = {security, dev_dna};

endmodule
