`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    13:11:55 06/25/2012 
// Design Name: 
// Module Name:    jtag_port 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module jtag_port(OUT_PORT, IN_PORT);
	parameter W = 8;
   output [W-1:0] OUT_PORT;
   input  [W-1:0] IN_PORT;

	reg [W-1:0] sreg;
	reg [W-1:0] oreg;
	assign OUT_PORT = oreg;
	assign tdo = sreg[0];
	
	wire capture;
	wire drclk;
	wire sel1;
	wire shift;
	wire tck;
	wire tdi;
	wire update;
	
	BSCAN_SPARTAN3A jtag (
		.CAPTURE(capture), 	// CAPTURE output from TAP controller
		.DRCK1(drclk), 		// Data register output for USER1 functions
		.DRCK2(), 				// Data register output for USER2 functions
		.RESET(), 				// Reset output from TAP controller
		.SEL1(sel1), 			// USER1 active output
		.SEL2(), 				// USER2 active output
		.SHIFT(shift), 		// SHIFT output from TAP controller
		.TCK(tck), 				// TCK output from TAP controller
		.TDI(tdi), 				// TDI output from TAP controller
		.TMS(), 					// TMS output from TAP controller
		.UPDATE(update), 		// UPDATE output from TAP controller
		.TDO1(tdo),				// Data input for USER1 function
		.TDO2(0) 				// Data input for USER2 function
	);
	
	always @(posedge drclk)
	begin
		if(capture)
			sreg <= IN_PORT;
		else if(shift)
			sreg <= {tdi,sreg[W-1:1]};
	end
	
	always @(posedge tck)
	begin
		if(update && sel1)
			oreg <= sreg;
	end
	
	
endmodule
